/* -*-Mode: C;-*-
 *
 * Copyright (C) 1999, 2000, Joshua P. MacDonald <jmacd@CS.Berkeley.EDU>
 * and The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 *    Neither name of The University of California nor the names of
 *    its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This file was AUTOMATICALLY GENERATED using:
 *
 * $Id: edsio.el 1.2 Tue, 13 Jun 2000 01:19:56 -0700 jmacd $
 */

#include "edsio.h"

#include "xdfs.h"

#ifndef _XDFS_EDSIO_H_
#define _XDFS_EDSIO_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "edsio_edsio.h"

/* Initialize this library. */

gboolean xdfs_edsio_init (void);

/* Types defined here. */

/* XdfsPathEventCode.
 */

typedef struct _XdfsPathEventCode XdfsPathEventCode;
struct _XdfsPathEventCode { gint code; };

typedef struct _XdfsPathEvent XdfsPathEvent;
struct _XdfsPathEvent { gint code; const char* srcfile; guint srcline; Path* path; };

/* XdfsVoidEventCode.
 */

typedef struct _XdfsVoidEventCode XdfsVoidEventCode;
struct _XdfsVoidEventCode { gint code; };

typedef struct _XdfsVoidEvent XdfsVoidEvent;
struct _XdfsVoidEvent { gint code; const char* srcfile; guint srcline; };

/* XdfsPathIntEventCode.
 */

typedef struct _XdfsPathIntEventCode XdfsPathIntEventCode;
struct _XdfsPathIntEventCode { gint code; };

typedef struct _XdfsPathIntEvent XdfsPathIntEvent;
struct _XdfsPathIntEvent { gint code; const char* srcfile; guint srcline; Path* path; int err; };

/* XdfsIntEventCode.
 */

typedef struct _XdfsIntEventCode XdfsIntEventCode;
struct _XdfsIntEventCode { gint code; };

typedef struct _XdfsIntEvent XdfsIntEvent;
struct _XdfsIntEvent { gint code; const char* srcfile; guint srcline; int err; };

typedef struct _SerialXdfsState SerialXdfsState;
typedef struct _SerialXdfsInstruction SerialXdfsInstruction;
/* Functions declared here. */

/* Serial Types */

enum _SerialXdfsType {

  ST_XdfsInstruction = (1<<(1+EDSIO_LIBRARY_OFFSET_BITS))+10, 
  ST_XdfsState = (1<<(3+EDSIO_LIBRARY_OFFSET_BITS))+10
};



/* XdfsInstruction Structure
 */

struct _SerialXdfsInstruction {
  guint32 offset;
  guint32 length;
  guint32 output_start;
  Inode       *inop;
};

void     serializeio_print_xdfsinstruction_obj        (SerialXdfsInstruction* obj, guint indent_spaces);

gboolean unserialize_xdfsinstruction                  (SerialSource *source, SerialXdfsInstruction**);
gboolean unserialize_xdfsinstruction_internal         (SerialSource *source, SerialXdfsInstruction** );
gboolean unserialize_xdfsinstruction_internal_noalloc (SerialSource *source, SerialXdfsInstruction* );
gboolean serialize_xdfsinstruction                    (SerialSink *sink, guint32 offset, guint32 length, guint32 output_start);
gboolean serialize_xdfsinstruction_obj                (SerialSink *sink, const SerialXdfsInstruction* obj);
gboolean serialize_xdfsinstruction_internal           (SerialSink *sink, guint32 offset, guint32 length, guint32 output_start);
gboolean serialize_xdfsinstruction_obj_internal (SerialSink *sink, SerialXdfsInstruction* obj);
guint    serializeio_count_xdfsinstruction            (guint32 offset, guint32 length, guint32 output_start);
guint    serializeio_count_xdfsinstruction_obj        (SerialXdfsInstruction const* obj);

/* XdfsState Structure
 */

struct _SerialXdfsState {
  guint32 src_buffer_files;
  guint32 src_buffer_size;
  guint32 total_version_count;
  guint32 unique_version_count;
  guint32 unencoded_size;
  guint32 literal_size;
  guint32 control_size;
  guint32 patch_size;
  guint32 patches;
  guint32 literals;
  guint32 src_buffer_copied;
  guint32 cluster_versions;
  guint32 cluster_compressed_size;
  guint32 cluster_uncompressed_size;
  guint32 policy;
  guint32 flags;
  guint32 cluster_max_versions;
  guint32 src_buffer_max_files;
  guint32 src_buffer_max_size;
  guint32 src_buffer_max_size_per_file;
  guint32 src_buffer_min_size_per_file;
};

void     serializeio_print_xdfsstate_obj        (SerialXdfsState* obj, guint indent_spaces);

gboolean unserialize_xdfsstate                  (SerialSource *source, SerialXdfsState**);
gboolean unserialize_xdfsstate_internal         (SerialSource *source, SerialXdfsState** );
gboolean unserialize_xdfsstate_internal_noalloc (SerialSource *source, SerialXdfsState* );
gboolean serialize_xdfsstate                    (SerialSink *sink, guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file);
gboolean serialize_xdfsstate_obj                (SerialSink *sink, const SerialXdfsState* obj);
gboolean serialize_xdfsstate_internal           (SerialSink *sink, guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file);
gboolean serialize_xdfsstate_obj_internal (SerialSink *sink, SerialXdfsState* obj);
guint    serializeio_count_xdfsstate            (guint32 src_buffer_files, guint32 src_buffer_size, guint32 total_version_count, guint32 unique_version_count, guint32 unencoded_size, guint32 literal_size, guint32 control_size, guint32 patch_size, guint32 patches, guint32 literals, guint32 src_buffer_copied, guint32 cluster_versions, guint32 cluster_compressed_size, guint32 cluster_uncompressed_size, guint32 policy, guint32 flags, guint32 cluster_max_versions, guint32 src_buffer_max_files, guint32 src_buffer_max_size, guint32 src_buffer_max_size_per_file, guint32 src_buffer_min_size_per_file);
guint    serializeio_count_xdfsstate_obj        (SerialXdfsState const* obj);

void xdfs_generate_int_event_internal (XdfsIntEventCode code, const char* srcfile, gint srcline, int err);
#define xdfs_generate_int_event(ecode, err) xdfs_generate_int_event_internal((ecode),__FILE__,__LINE__, (err))

extern const XdfsIntEventCode EC_XdfsDbOpen;
#define EC_XdfsDbOpenValue ((0<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbClose;
#define EC_XdfsDbCloseValue ((1<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbEnvClose;
#define EC_XdfsDbEnvCloseValue ((2<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbCreate;
#define EC_XdfsDbCreateValue ((3<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbSet;
#define EC_XdfsDbSetValue ((4<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbGet;
#define EC_XdfsDbGetValue ((5<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbPut;
#define EC_XdfsDbPutValue ((6<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbDel;
#define EC_XdfsDbDelValue ((7<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbTxnBegin;
#define EC_XdfsDbTxnBeginValue ((8<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbTxnCommit;
#define EC_XdfsDbTxnCommitValue ((9<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbTxnAbort;
#define EC_XdfsDbTxnAbortValue ((10<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbTxnCheckpoint;
#define EC_XdfsDbTxnCheckpointValue ((11<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbMempFopen;
#define EC_XdfsDbMempFopenValue ((12<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbMempFget;
#define EC_XdfsDbMempFgetValue ((13<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbMempFclose;
#define EC_XdfsDbMempFcloseValue ((14<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbMempFput;
#define EC_XdfsDbMempFputValue ((15<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbEnvCreate;
#define EC_XdfsDbEnvCreateValue ((16<<EDSIO_LIBRARY_OFFSET_BITS)+10)

void xdfs_generate_pathint_event_internal (XdfsPathIntEventCode code, const char* srcfile, gint srcline, Path* path, int err);
#define xdfs_generate_pathint_event(ecode, path, err) xdfs_generate_pathint_event_internal((ecode),__FILE__,__LINE__, (path), (err))

extern const XdfsPathIntEventCode EC_XdfsDbEnvOpen;
#define EC_XdfsDbEnvOpenValue ((17<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbCursor;
#define EC_XdfsDbCursorValue ((18<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbCursorGet;
#define EC_XdfsDbCursorGetValue ((19<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbCursorDel;
#define EC_XdfsDbCursorDelValue ((20<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsDbCursorClose;
#define EC_XdfsDbCursorCloseValue ((21<<EDSIO_LIBRARY_OFFSET_BITS)+10)

void xdfs_generate_void_event_internal (XdfsVoidEventCode code, const char* srcfile, gint srcline);
#define xdfs_generate_void_event(ecode) xdfs_generate_void_event_internal((ecode),__FILE__,__LINE__)

extern const XdfsVoidEventCode EC_XdfsMissingInode;
#define EC_XdfsMissingInodeValue ((22<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsMissingLink;
#define EC_XdfsMissingLinkValue ((23<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsMissingShort;
#define EC_XdfsMissingShortValue ((24<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsInvalidRecordLength;
#define EC_XdfsInvalidRecordLengthValue ((25<<EDSIO_LIBRARY_OFFSET_BITS)+10)

void xdfs_generate_path_event_internal (XdfsPathEventCode code, const char* srcfile, gint srcline, Path* path);
#define xdfs_generate_path_event(ecode, path) xdfs_generate_path_event_internal((ecode),__FILE__,__LINE__, (path))

extern const XdfsPathEventCode EC_XdfsLinkDepthExceeded;
#define EC_XdfsLinkDepthExceededValue ((26<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsIndirectLinkDepthExceeded;
#define EC_XdfsIndirectLinkDepthExceededValue ((27<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsImmutableContainer;
#define EC_XdfsImmutableContainerValue ((28<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsFileExists;
#define EC_XdfsFileExistsValue ((29<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsMalformedCanonicalPath;
#define EC_XdfsMalformedCanonicalPathValue ((30<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsOpenWriteFailed;
#define EC_XdfsOpenWriteFailedValue ((31<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsOpenReadFailed;
#define EC_XdfsOpenReadFailedValue ((32<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsMmapFailed;
#define EC_XdfsMmapFailedValue ((33<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsMunmapFailed;
#define EC_XdfsMunmapFailedValue ((34<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsWriteFailed;
#define EC_XdfsWriteFailedValue ((35<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsCloseFailed;
#define EC_XdfsCloseFailedValue ((36<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathIntEventCode EC_XdfsMkdirFailed;
#define EC_XdfsMkdirFailedValue ((37<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsInvalidFileType;
#define EC_XdfsInvalidFileTypeValue ((38<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathEventCode EC_XdfsNotADirectory;
#define EC_XdfsNotADirectoryValue ((39<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsPathIntEventCode EC_XdfsStatFailed;
#define EC_XdfsStatFailedValue ((40<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsAlreadyExists;
#define EC_XdfsAlreadyExistsValue ((41<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsNoSuchView;
#define EC_XdfsNoSuchViewValue ((42<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsCannotDeleteRoot;
#define EC_XdfsCannotDeleteRootValue ((43<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsIntEventCode EC_XdfsUnlinkFailed;
#define EC_XdfsUnlinkFailedValue ((44<<EDSIO_LIBRARY_OFFSET_BITS)+10)

extern const XdfsVoidEventCode EC_XdfsFsyncFailed;
#define EC_XdfsFsyncFailedValue ((45<<EDSIO_LIBRARY_OFFSET_BITS)+10)

#ifdef __cplusplus
}
#endif

#endif /* _XDFS_EDSIO_H_ */

